package com.eco.plugin.xxx.jmcwmsg.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "消息推送配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.eco.plugin.xxx.jmcwmsg.config", text = "消息推送配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "funcKey", name = "轻应用key", description = "轻应用key", status = Status.SHOW)
    private Conf<String> funcKey = Holders.simple("");

    @Identifier(value = "url", name = "接口地址", description = "接口地址", status = Status.SHOW)
    private Conf<String> url = Holders.simple("");

    @Identifier(value = "frdomain", name = "帆软域名", description = "帆软域名", status = Status.SHOW)
    private Conf<String> frdomain = Holders.simple("");

    @Identifier(value = "prefix", name = "url前缀", description = "url前缀", status = Status.SHOW)
    private Conf<String> prefix = Holders.simple("");

    public String getFuncKey() {
        return funcKey.get();
    }

    public void setFuncKey(String url) {
        this.funcKey.set(url);
    }

    public String getUrl() {
        return url.get();
    }

    public void setUrl(String url) {
        this.url.set(url);
    }

    public String getFrdomain() {
        return frdomain.get();
    }

    public void setFrdomain(String url) {
        this.frdomain.set(url);
    }

    public String getPrefix() {
        return prefix.get();
    }

    public void setPrefix(String url) {
        this.prefix.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
