package com.eco.plugin.xxx.jmcwmsg.dsdd.dsdd;

import com.fr.schedule.base.bean.output.BaseOutputAction;
import com.fr.schedule.base.entity.AbstractScheduleEntity;
import com.fr.schedule.base.type.RunType;
import com.fr.third.fasterxml.jackson.annotation.JsonSubTypes;

@JsonSubTypes.Type(value = TsBean.class, name = "TsBean")
public class TsBean extends BaseOutputAction {
    private static final long serialVersionUID = 8245931480823179622L;
    private String content = null;
    private String msgtype = null;
    private String title = null;

    public TsBean(){
        super();
    }

    //是否受不同用户生成不同附件影响
    @Override
    public boolean willExecuteByUser() {
        return true;
    }

    @Override
    public RunType runType() {
        return RunType.SEND_EMAIL;
    }

    //这里直接关联第一步的entity类
    @Override
    public Class<? extends AbstractScheduleEntity> outputActionEntityClass() {
        return TsEntity.class;
    }

    public TsBean id(String id){
        setId(id);
        return this;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public TsBean content(String content){
        setContent(content);
        return this;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public TsBean title(String title){
        setTitle(title);
        return this;
    }

    public String getMsgtype() {
        return msgtype;
    }

    public void setMsgtype(String type) {
        this.msgtype = type;
    }

    public TsBean msgtype(String type){
        setMsgtype(type);
        return this;
    }

    //转换成entity对象，用于数据库存储，注意属性不要漏了
    @Override
    public TsEntity createOutputActionEntity() {
        return new TsEntity()
                .id(this.getId())
                .content(this.getContent())
                .msgtype(this.getMsgtype())
                .title(this.getTitle())
                ;
    }
}
