package com.eco.plugin.xxx.jmcwmsg.dsdd.dsdd;

import com.eco.plugin.xxx.jmcwmsg.config.PluginSimpleConfig;
import com.eco.plugin.xxx.jmcwmsg.utils.DataOpUtils;
import com.eco.plugin.xxx.jmcwmsg.utils.FRUtils;
import com.fr.schedule.base.bean.ScheduleTask;
import com.fr.schedule.base.controller.ScheduleTaskController;
import com.fr.schedule.feature.ScheduleContext;
import com.fr.schedule.feature.output.OutputActionHandler;
import com.fr.stable.query.QueryFactory;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Map;

public class TsHandler extends OutputActionHandler<TsBean>{
    @Override
    public void doAction(TsBean tsBean, Map<String, Object> map){
        String userCodes = String.valueOf(map.get("username"));
        String funcUrl = getTempUrl(tsBean,map);
        String msgType = tsBean.getMsgtype();
        String title = tsBean.getTitle();
        String content = tsBean.getContent();

        DataOpUtils.sendMsg(userCodes,msgType,title,content,funcUrl, PluginSimpleConfig.getInstance());
    }

    /**
     * 获取定时调度
     * @param taskName
     * @return
     */
    private static ScheduleTask getTask(String taskName){
        ScheduleTask scheduleTask = null;
        try {
            ScheduleTaskController scheduleTaskController = ScheduleContext.getInstance().getScheduleTaskController();
            scheduleTask = scheduleTaskController.getByTaskName(taskName,QueryFactory.create());
        } catch (Exception e) {
            FRUtils.FRLogInfo("任务异常:"+e.getMessage());
            return null;
        }

        return scheduleTask;
    }

    /**
     * 获取模板链接
     * @param map
     * @return
     */
    private static String getTempUrl(TsBean tsBean,Map<String, Object> map){

        String taskName = String.valueOf(map.get("taskName"));

        ScheduleTask scheduleTask = getTask(taskName);

        int showType = scheduleTask.getShowType();
        String templateName = scheduleTask.getTemplatePath();
        try {
            templateName = URLEncoder.encode(templateName,"utf-8");
        } catch (UnsupportedEncodingException e) {
            FRUtils.FRLogInfo("编码模板名称异常:"+e.getMessage());
            return "";
        }

        if(1 == showType){
            templateName+="&op=write";
        }
        else if(2 == showType){
            templateName += "&op=view";
        }
        else if(3 == showType){
            templateName += "&op=write_plus";
        }

        return tsBean.getResultURL()+"/view/report?viewlet="+templateName;
    }

    /**
     * 获取用户组信息
     * @param map
     * @return
     */
    private static String[] getUserGroup(Map<String, Object> map){
        String taskName = String.valueOf(map.get("taskName"));
        ScheduleTask scheduleTask = getTask(taskName);

        return scheduleTask.getUserGroup().createUserNameArray();
    }

}
