package com.eco.plugin.wink.jmcwmsg.utils;

import com.eco.plugin.wink.jmcwmsg.config.PluginSimpleConfig;

import java.util.HashMap;
import java.util.Map;

/**
 * 数据操作类
 */
public class DataOpUtils {

    /**
     * 发送短信
     * @param userCodes
     * @param msgType
     * @param title
     * @param content
     * @param funcUrl
     * @param psc
     * @return
     */
    public static boolean sendMsg(String userCodes, String msgType, String title, String content, String funcUrl, PluginSimpleConfig psc){
        funcUrl = operUrl(funcUrl,psc);
        String param = genParam(userCodes, msgType, title, content, psc.getFuncKey(), funcUrl);

        String result = HttpUtils.HttpPostText(psc.getUrl(),param);

        if(Utils.isNullStr(result)){
            return false;
        }

        Map<String,String> resultMap = getResult(result);

        return resultMap.get("code").equals("200");
    }

    /**
     * 操作url
     * @param url
     * @param psc
     * @return
     */
    private static String operUrl(String url,PluginSimpleConfig psc){
        return psc.getPrefix()+url.replaceAll(psc.getFrdomain(),"");
    }

    /**
     * 获取请求结果
     * @param result
     * @return
     */
    private static Map<String,String> getResult(String result){
        String code = result.substring(result.indexOf("<msgCode>")+9,result.indexOf("</msgCode>"));
        String msg = result.substring(result.indexOf("<message>")+9,result.indexOf("</message>"));

        Map<String,String> resultMap = new HashMap<>();
        resultMap.put("code",code);
        resultMap.put("msg",msg);

        return resultMap;
    }

    /**
     * 生产请求参数
     * @param userCodes
     * @param msgType
     * @param title
     * @param content
     * @param funcKey
     * @param funcUrl
     * @return
     */
    private static String genParam(String userCodes,String msgType,String title,String content,String funcKey,String funcUrl){
        String paramText = "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:shw=\"http://shwocase.example.kingnode.com\">\n" +
                "   <soapenv:Header/>\n" +
                "   <soapenv:Body>\n" +
                "      <shw:push>\n" +
                "         <!--Zero or more repetitions:-->\n" +
                "         <userCodes>#userCodes</userCodes>\n" +
                "         <!--Optional:-->\n" +
                "         <msgType>#msgType</msgType>\n" +
                "         <!--Optional:-->\n" +
                "         <title><![CDATA[#title]]></title>\n" +
                "         <!--Optional:-->\n" +
                "         <content><![CDATA[#content]]></content>\n" +
                "         <!--Optional:-->\n" +
                "         <funcKey>#funcKey</funcKey>\n" +
                "         <!--Optional:-->\n" +
                "         <funcUrl>#funcUrl</funcUrl>\n" +
                "      </shw:push>\n" +
                "   </soapenv:Body>\n" +
                "</soapenv:Envelope>";

        return paramText.replaceAll("#userCodes",userCodes).replaceAll("#msgType",msgType).replaceAll("#title",title)
                .replaceAll("#content",content).replaceAll("#funcKey",funcKey).replaceAll("#funcUrl",funcUrl);
    }
}
